/*
 * INIT.c
 *
 *  Created on: 13.11.2010
 *      Author: Filip
 */
#include "compiler.h"
#include "INIT.h"


void init_all (void)
{/*
	//	NASTAVEN ZDROJE HODIN
		  pm_enable_osc0_crystal(&AVR32_PM, FOSC0);  // Osc
		  pm_enable_clk0(&AVR32_PM, OSC0_STARTUP);
		  pm_pll_setup(&AVR32_PM, 0, // pll.
		  10, 	// mul.
		  1, 	// div.
		  0, 	// osc.
		  16);	// lockcount.
		  pm_pll_set_option(&AVR32_PM, 0, // pll.
		  1, 	// pll_freq.
		  1, 	// pll_div2.
		  0);	// pll_wbwdisable.
		  pm_pll_enable(&AVR32_PM, 0);
		  pm_wait_for_pll0_locked(&AVR32_PM);
		  pm_cksel(&AVR32_PM,
		  0, 	// pbadiv.
		  0, 	// pbasel.
		  0, 	// pbbdiv.
		  0, 	// pbbsel.
		  1, 	// hsbdiv.
		  0);	// hsbsel.
		   pm_switch_to_clock(&AVR32_PM, AVR32_PM_MCSEL_PLL0);

		 //	PWM
		   unsigned int channel_id = 0;
		   gpio_enable_module_pin(AVR32_PWM_0_PIN, AVR32_PWM_0_FUNCTION);
		      // PWM konfigurace
		      pwm_opt.diva = AVR32_PWM_DIVA_CLK_OFF;
		      pwm_opt.divb = AVR32_PWM_DIVB_CLK_OFF;
		      pwm_opt.prea = AVR32_PWM_PREA_MCK;
		      pwm_opt.preb = AVR32_PWM_PREB_MCK;

		      pwm_init(&pwm_opt);

		      pwm_channel.CMR.calg = PWM_MODE_LEFT_ALIGNED;       	// Channel mode.
		      pwm_channel.CMR.cpol = PWM_POLARITY_LOW;            	// Channel polarity.
		      pwm_channel.CMR.cpd = PWM_UPDATE_DUTY;              	// Not used the first time.

		      pwm_channel.CMR.cpre = AVR32_PWM_CPRE_MCK_DIV_32;		// Channel prescaler. //s dlikouAVR32_PWM_CPRE_MCK_DIV_2
		      pwm_channel.cdty = 600;   	// Channel duty cycle, should be < CPRD. //cdty*976/1000=time ms
		      pwm_channel.cprd = 20000;  	// Channel period.

		      pwm_channel_init(channel_id, &pwm_channel); 	// Set channel configuration to channel 0.
		      pwm_start_channels(1 << channel_id);  // Start channel 0

		 // USART
		static const gpio_map_t USART1_GPIO_MAP =
		  {
		    {MAIN_USART_RX_PIN, MAIN_USART_RX_FUNCTION},
		    {MAIN_USART_TX_PIN, MAIN_USART_TX_FUNCTION}
		  };
		static const gpio_map_t USART2_GPIO_MAP =
			  {
			    {AHRS_USART_RX_PIN, AHRS_USART_RX_FUNCTION},
			    {AHRS_USART_TX_PIN, AHRS_USART_TX_FUNCTION}
			  };
		 // USART NASTAVEN
		  static const usart_options_t USART1_OPTIONS =
		  {
		    .baudrate     = 115200,
		    .charlength   = 8,
		    .paritytype   = USART_NO_PARITY,
		    .stopbits     = USART_1_STOPBIT,
		    .channelmode  = USART_NORMAL_CHMODE
		  };
		  static const usart_options_t USART2_OPTIONS =
		  	  {
		  	    .baudrate     = 38400,
		  	    .charlength   = 8,
		  	    .paritytype   = USART_NO_PARITY,
		  	    .stopbits     = USART_1_STOPBIT,
		  	    .channelmode  = USART_NORMAL_CHMODE
		  	  };

		  gpio_enable_module(USART1_GPIO_MAP,
		  sizeof(USART1_GPIO_MAP) / sizeof(USART1_GPIO_MAP[0]));

		  gpio_enable_module(USART2_GPIO_MAP,
		  sizeof(USART2_GPIO_MAP) / sizeof(USART2_GPIO_MAP[0]));

		  usart_reset(AHRS_USART);
		  usart_init_rs232(AHRS_USART, &USART2_OPTIONS, PBACLK_FREQ_HZ);
		  usart_reset(MAIN_USART);
		  usart_init_rs232(MAIN_USART, &USART1_OPTIONS, PBACLK_FREQ_HZ);

		 // TC
		  tc_waveform_opt_t waveform_opt =
		    {
		      .channel  = TC_0_CHANNEL_ID,        // Channel selection.

		      .bswtrg   = TC_EVT_EFFECT_NOOP,           // Software trigger effect on TIOB.
		      .beevt    = TC_EVT_EFFECT_NOOP,           // External event effect on TIOB.
		      .bcpc     = TC_EVT_EFFECT_NOOP,           // RC compare effect on TIOB.
		      .bcpb     = TC_EVT_EFFECT_NOOP,           // RB compare effect on TIOB.

		      .aswtrg   = TC_EVT_EFFECT_NOOP,           // Software trigger effect on TIOA.
		      .aeevt    = TC_EVT_EFFECT_NOOP,           // External event effect on TIOA.
		      .acpc     = TC_EVT_EFFECT_TOGGLE,         // RC compare effect on TIOA: toggle.
		      .acpa     = TC_EVT_EFFECT_TOGGLE,         // RA compare effect on TIOA: toggle (other possibilities are none, set and clear).

		      .wavsel   = TC_WAVEFORM_SEL_UP_MODE_RC_TRIGGER,
		      .enetrg   = FALSE,                        // External event trigger enable.
		      .eevt     = TC_EXT_EVENT_SEL_TIOB_INPUT,  // External event selection.
		      .eevtedg  = TC_SEL_NO_EDGE,               // External event edge selection.
		      .cpcdis   = FALSE,                        // Counter disable when RC compare.
		      .cpcstop  = FALSE,                        // Counter clock stopped with RC compare.

		      .burst    = TC_BURST_NOT_GATED,           // Burst signal selection.
		      .clki     = TC_CLOCK_RISING_EDGE,         // Clock inversion.
		      .tcclks   = TC_CLOCK_SOURCE_TC4
		    };

		  gpio_enable_module_pin(TC_0_CHANNEL_PIN, TC_0_CHANNEL_FUNCTION);

		    // Initialize the timer/counter.
		  tc_init_waveform(tc, &waveform_opt);  // Initialize the timer/counter waveform.
		    // Set the compare triggers.
		  tc_write_ra(tc, TC_0_CHANNEL_ID, 65535);     // Set RA value.
		  tc_write_rc(tc, TC_0_CHANNEL_ID, 65535);     // Set RC value.
		    // Start the timer/counter.
		  tc_start(tc, TC_0_CHANNEL_ID);





		  Disable_global_interrupt();
		  INTC_init_interrupts();
		  INTC_register_interrupt(&usart_int_handler, AHRS_USART_IRQ, AVR32_INTC_INT3);
		  AHRS_USART->ier = AVR32_USART_IER_RXRDY_MASK;*/
}
