/*
 * PID.h
 *
 *  Created on: 27.10.2010
 *      Author: Filip
 */

#ifndef PID_H_
#define PID_H_

typedef struct
{
  float pgain;
  float igain;
  float dgain;
  float p;
  float i;
  float d;
  float start_fuse;
  float last_value;
  float istate;

} pid_t;

float PID (pid_t *select, float w, float y);
void PID_setup (pid_t *select, float pgain, float igain, float dgain, float fusegain);
#endif /* PID_H_ */
