/*
 * buzzer.h
 *
 *  Created on: 21.11.2010
 *      Author: Filip
 */

#ifndef BUZZER_H_
#define BUZZER_H_

#include "tc.h"
#include "gpio.h"

#define TC_1_CHANNEL_ID         	1
#define TC_1_CHANNEL_PIN        	AVR32_TC_A1_0_0_PIN
#define TC_1_CHANNEL_FUNCTION   	AVR32_TC_A1_0_0_FUNCTION
#define TC_1_IRQ         			AVR32_TC_IRQ1
#define TC                  	  	(&AVR32_TC)

void buzzer_initialize();
void buzzer_on(int frequency);
void buzzer_off();
void buzzer_set(int frequency);

#endif /* BUZZER_H_ */
