/*
 * error.h
 *
 *  Created on: 6.3.2011
 *      Author: Filip
 */

#ifndef ERROR_H_
#define ERROR_H_
typedef struct
{
  int last_error;
  int high_priority;
  int transmit_error;
  int error_count;
} error_t;

void error_report(error_t *handler,int code);
int error_transmit(error_t *handler);
int error_get_last(error_t *handler);
int error_get_hp(error_t *handler);
void error_clear_all(error_t *handler);
int error_is_error(error_t *handler);
int error_counter(error_t *handler);

#endif /* ERROR_H_ */
